/* osgCompute - Copyright (C) 2008-2009 SVT Group
 *                                                                     
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 3 of
 * the License, or (at your option) any later version.
 *                                                                     
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesse General Public License for more details.
 *
 * The full license is in LICENSE file included with this distribution.
*/

uniform vec2 pixelsize;

void main(void)
{
    // decrease pixel size with increasing distance to the 
    // eye point
    vec4 worldPos = vec4(gl_Vertex.x,gl_Vertex.y,gl_Vertex.z,1.0);
    vec4 projPos = gl_ModelViewProjectionMatrix * worldPos;

    float dist = projPos.z / projPos.w;
    float distAlpha = (dist+1.0)/2.0;
    gl_PointSize = pixelsize.y - distAlpha * (pixelsize.y - pixelsize.x);

    // return projection position
    gl_Position = projPos;
}
